#lang racket/base

(require parser-tools/lex
         parser-tools/yacc)

(define-tokens toks
  (La Ln))

(define-empty-tokens etoks
  (Lw Lend))

(define tokens
  (lexer
   ((eof)      (token-Lend))
   (alphabetic (token-La lexeme))
   (numeric    (token-Ln (string->number lexeme)))
   (whitespace (token-Lw))))

;; écrire vos analyseurs syntaxiques ici

(define argv (current-command-line-arguments))
(cond
  ((= (vector-length argv) 1)
   (define in (open-input-string (vector-ref argv 0)))
   (define lex (lambda () (tokens in)))
   ;; appeler vos analyseurs syntaxiques ici et écrire ce
   ;; qu'ils retournent sur la sortie standard.
   (close-input-port in)
   (exit 0))
  (else
   (eprintf "Usage: racket parsers.rkt \"string\"\n")
   (exit 1)))
